package com.cxytiandi.cache_sdk.config;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.DependsOn;

import com.alicp.jetcache.autoconfigure.JedisPoolFactory;
import com.alicp.jetcache.autoconfigure.RedisAutoConfiguration;
import com.cxytiandi.cache_sdk.CachePlus;
import com.cxytiandi.cache_sdk.CachePlusImpl;
import com.cxytiandi.cache_sdk.lock.DefaultLock;
import com.cxytiandi.cache_sdk.lock.Lock;
import com.cxytiandi.cache_sdk.ratelimit.DefaultRateLimit;
import com.cxytiandi.cache_sdk.ratelimit.RateLimit;

import redis.clients.jedis.JedisPool;

@Configuration
public class CachePlusAutoConfiguration {
	
	@Autowired(required=false)
	private Lock lock;
	
	@Autowired(required=false)
	private RateLimit rateLimit;
	
	@Bean(name = "defaultPool")
	@DependsOn(RedisAutoConfiguration.AUTO_INIT_BEAN_NAME)//jetcache2.2+
	//@DependsOn("redisAutoInit")//jetcache2.1
	public JedisPoolFactory defaultPool() {
	    return new JedisPoolFactory("remote.default", JedisPool.class);
	}
	
	@Bean
	public CachePlus cache() {
		if (lock == null) {
			lock = new DefaultLock();
		}
		if (rateLimit == null) {
			rateLimit = new DefaultRateLimit();
		}
		return new CachePlusImpl(lock, rateLimit);
	}
}
