package com.cxytiandi.jetcache;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alicp.jetcache.Cache;
import com.alicp.jetcache.anno.CreateCache;
import com.cxytiandi.cache_sdk.HotKey;
import com.cxytiandi.jetcache.service.UserService;

@RestController
public class TestController {

	@CreateCache(expire = 100)
	private Cache<Long, User> userCache;
	
	@Autowired
	private UserService userService;
	
	@GetMapping("/test")
	public String test() {
		User user = new User();
		user.setId(1L);
		user.setName("yinjihuan");
//		userCache.put(1L, user);
		User user2 = userService.getUser(1L);
		return user2.getName();
	}
	
	@GetMapping("/remove")
	public String remove() {
		userCache.remove(1L);
		return "success";
	}
	
	@GetMapping("/hot")
	public String hot(String key) {
		HotKey.addHotKey(key);
		return "success";
	}
}
