package com.cxytiandi.jetcache.service;

import java.util.concurrent.TimeUnit;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alicp.jetcache.anno.Cached;
import com.cxytiandi.cache_sdk.CachePlus;
import com.cxytiandi.cache_sdk.Closure;
import com.cxytiandi.jetcache.User;
import com.google.common.hash.BloomFilter;
import com.google.common.hash.Funnels;
import com.sun.org.apache.xml.internal.security.Init;

@Service
public class UserServiceImpl implements UserService {

	@Autowired
	private UserService userService;
	
//	@CacheRefresh(refresh=5)

	private BloomFilter<Long> userIdBloomFilter = BloomFilter.create(Funnels.longFunnel(), 100000, 0.0003);
	
	@Autowired
	private CachePlus cachePlus;
	
	@PostConstruct
	private void init() {
		for (long i = 1; i <= 100000; i++) {
			userIdBloomFilter.put(i);
		}
		int count = 0;
		for (long i = 1; i <= 110000; i++) {
			if (userIdBloomFilter.mightContain(i)) {
				count++;
			}
		}
		System.err.println(count);
	}
	
	@Override
	public User getUser(Long id) {
		if (!userIdBloomFilter.mightContain(id)) {
			return null;
		}
		
		return cachePlus.getCache("getUser", id, new Closure<User, Long>() {

			@Override
			public User execute(Long input) {
				User user = new User();
				user.setId(11L);
				user.setName("xxx");
				return user;
			}
			
		}, 20, TimeUnit.SECONDS);
	
		//userService.getUser2(user, 1L);
		//return user;
	}

	@Cached(name="getUser2.",  expire = 3600)
	@Override
	public User getUser2(User u, Long id) {
		User user = new User();
		user.setId(1L);
		user.setName("xxx");
		return user;
	}

}
